import pygame
from pygame.locals import *

class Sprite:
    def __init__(self, globex, globey, tile_size = 50):
        self.tile_size = tile_size
        self.globex, self.globey = globex, globey

        self._tile_y_offset = tile_size / 2
        self._tile_x_offset = tile_size / 2

    def draw(self, surf):
        locx = (self.tile_x*self.tile_size) + self._tile_x_offset + self.globex
        locy = (self.tile_y*self.tile_size) + self._tile_y_offset + self.globey
        surf.blit(self.image, (locx, locy))
        return []

    def move_north(self):
        self._tile_y_offset -= 1
        if self._tile_y_offset <= 0:
            self.tile_y -= 1
            self._tile_y_offset = self.tile_size

    def move_south(self):
        self._tile_y_offset += 1
        if self._tile_y_offset >= self.tile_size:
            self.tile_y += 1
            self._tile_y_offset = 0

    def move_west(self):
        self._tile_x_offset -= 1
        if self._tile_x_offset <= 0:
            self.tile_x -= 1
            self._tile_x_offset = self.tile_size

    def move_east(self):
        self._tile_x_offset += 1
        if self._tile_x_offset >= self.tile_size:
            self.tile_x += 1
            self._tile_x_offset = 0

    def move_north_west(self):
        self._tile_y_offset -= 1
        if self._tile_y_offset <= 0:
            self.tile_y -= 1
            self._tile_y_offset = self.tile_size
        self._tile_x_offset -= 1
        if self._tile_x_offset <= 0:
            self.tile_x -= 1
            self._tile_x_offset = self.tile_size

    def move_north_east(self):
        self._tile_y_offset -= 1
        if self._tile_y_offset <= 0:
            self.tile_y -= 1
            self._tile_y_offset = self.tile_size
        self._tile_x_offset += 1
        if self._tile_x_offset >= self.tile_size:
            self.tile_x += 1
            self._tile_x_offset = 0

    def move_south_west(self):
        self._tile_y_offset += 1
        if self._tile_y_offset >= self.tile_size:
            self.tile_y += 1
            self._tile_y_offset = 0
        self._tile_x_offset -= 1
        if self._tile_x_offset <= 0:
            self.tile_x -= 1
            self._tile_x_offset = self.tile_size

    def move_south_east(self):
        self._tile_y_offset += 1
        if self._tile_y_offset >= self.tile_size:
            self.tile_y += 1
            self._tile_y_offset = 0
        self._tile_x_offset += 1
        if self._tile_x_offset >= self.tile_size:
            self.tile_x += 1
            self._tile_x_offset = 0
